glibmm: Gio::SocketControlMessage Class Reference

glibmm 2.28.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gio::SocketControlMessage Class Reference
Portable Network I/O Functionality

SocketControlMessage - A Socket control message. More...

`#include <giomm/socketcontrolmessage.h>`

Inheritance diagram for Gio::SocketControlMessage:
[legend]

List of all members.

## Public Member Functions
virtual | ~SocketControlMessage ()
GSocketControlMessage* | gobj ()
| Provides access to the underlying C GObject.
const GSocketControlMessage* | gobj () const
| Provides access to the underlying C GObject.
GSocketControlMessage* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_level () const
| Returns the "level" (i.e. the originating protocol) of the control message.
int | get_msg_type () const
| Returns the protocol specific type of the control message.
gsize | get_size () const
| Returns the space required for the control message, not including headers or alignment.
void | serialize (gpointer data)
| Converts the data in the message to bytes placed in the message.
virtual gsize | get_size_vfunc () const
virtual int | get_level_vfunc () const
virtual int | get_type_vfunc () const
virtual void | serialize_vfunc (gpointer data)
## Static Public Member Functions
static Glib::RefPtr < SocketControlMessage > | deserialize (int level, int type, gsize size, gpointer data)
| Tries to deserialize a socket control message of a given level and type.
## Protected Member Functions
| SocketControlMessage ()
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::SocketControlMessage > | wrap (GSocketControlMessage* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

SocketControlMessage - A Socket control message.

A SocketControlMessage is a special-purpose utility message that can be sent to or received from a Socket. These types of messages are often called "ancillary data".

The message can represent some sort of special instruction to or information from the socket or can represent a special kind of transfer to the peer (for example, sending a file description over a UNIX socket).

These messages are sent with Gio::Socket::send() and received with Gio::Socket::receive().

To extend the set of control message that can be sent, subclass this class and override the get_size, get_level, get_type and serialize methods.

To extend the set of control messages that can be received, subclass this class and implement the deserialize method. Also, make sure your class is registered with the GType typesystem before calling Gio::Socket::receive() to read such a message.

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::SocketControlMessage::~SocketControlMessage | ( |  | ) | `[virtual]`

Gio::SocketControlMessage::SocketControlMessage | ( |  | ) | `[protected]`

## Member Function Documentation

static Glib::RefPtr<SocketControlMessage> Gio::SocketControlMessage::deserialize | ( | int | level,
|  | int | type,
|  | gsize | size,
|  | gpointer | data
| ) |  | `[static]`

Tries to deserialize a socket control message of a given level and type.

This will ask all known (to GType) subclasses of SocketControlMessage if they can understand this kind of message and if so deserialize it into a SocketControlMessage.

If there is no implementation for this kind of control message, `0` will be returned.

Since glibmm 2.22:

Parameters:

  level | A socket level.
  type | A socket control message type for the given level.
  size | The size of the data in bytes.
  data | Pointer to the message data.

Returns:
  The deserialized message or `0`.

int Gio::SocketControlMessage::get_level | ( |  | ) | const

Returns the "level" (i.e. the originating protocol) of the control message.

This is often SOL_SOCKET.

Since glibmm 2.22:

Returns:
  An integer describing the level.

virtual int Gio::SocketControlMessage::get_level_vfunc | ( |  | ) | const`[virtual]`

int Gio::SocketControlMessage::get_msg_type | ( |  | ) | const

Returns the protocol specific type of the control message.

For instance, for UNIX fd passing this would be SCM_RIGHTS.

Since glibmm 2.22:

Returns:
  An integer describing the type of control message.

gsize Gio::SocketControlMessage::get_size | ( |  | ) | const

Returns the space required for the control message, not including headers or alignment.

Since glibmm 2.22:

Returns:
  The number of bytes required.

virtual gsize Gio::SocketControlMessage::get_size_vfunc | ( |  | ) | const`[virtual]`

virtual int Gio::SocketControlMessage::get_type_vfunc | ( |  | ) | const`[virtual]`

const GSocketControlMessage* Gio::SocketControlMessage::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

Reimplemented in Gio::UnixCredentialsMessage, and Gio::UnixFDMessage.

GSocketControlMessage* Gio::SocketControlMessage::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

Reimplemented in Gio::UnixCredentialsMessage, and Gio::UnixFDMessage.

GSocketControlMessage* Gio::SocketControlMessage::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented in Gio::UnixCredentialsMessage, and Gio::UnixFDMessage.

void Gio::SocketControlMessage::serialize | ( | gpointer | data | ) |

Converts the data in the message to bytes placed in the message.

data is guaranteed to have enough space to fit the size returned by g_socket_control_message_get_size() on this object.

Since glibmm 2.22:

Parameters:

  data | A buffer to write data to.

virtual void Gio::SocketControlMessage::serialize_vfunc | ( | gpointer | data | ) | `[virtual]`

## Friends And Related Function Documentation

Glib::RefPtr< Gio::SocketControlMessage > wrap | ( | GSocketControlMessage * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.